unit FormMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, VaComm, VaProtocol, VaClasses, VaZmodem, VaConfigDialog;

type
  TFrmMain = class(TForm)
    VaComm1: TVaComm;
    BtnReceive: TButton;
    BtnCancel: TButton;
    Memo1: TMemo;
    Button1: TButton;
    VaZModem1: TVaZModem;
    VaConfigDialog1: TVaConfigDialog;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure VaYModem1PacketEvent(Sender: TObject; Packet,
      ByteCount: Integer);
    procedure BtnReceiveClick(Sender: TObject);
    procedure BtnCancelClick(Sender: TObject);
    procedure VaYModem1FileInfo(Sender: TObject; const Name: String;
      Size: Integer);
    procedure VaYModem1TransferStart(Sender: TObject);
    procedure VaYModem1TransferEnd(Sender: TObject; ExitCode: Integer);
    procedure VaYModem1Error(Sender: TObject; ErrorCode,
      ErrorCount: Integer);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmMain: TFrmMain;

implementation

{$R *.DFM}

procedure TFrmMain.FormCreate(Sender: TObject);
begin
  vacomm1.Baudrate := br9600;
  vacomm1.PortNum := 1;
  VaComm1.Open;
end;

procedure TFrmMain.BtnReceiveClick(Sender: TObject);
begin
  VaZModem1.TargetFolder := '.\';
  VaZModem1.Mode := tmDownload;
  VaZModem1.Execute;
end;

procedure TFrmMain.BtnCancelClick(Sender: TObject);
begin
  VaZModem1.Cancel;
end;

procedure TFrmMain.VaYModem1FileInfo(Sender: TObject; const Name: String;
  Size: Integer);
begin
  Memo1.Lines.Add('File '+ Name + ' ' + IntToStr(Size) + ' bytes');
end;

procedure TFrmMain.VaYModem1TransferStart(Sender: TObject);
begin
  Memo1.Lines.Clear;
  Memo1.Lines.Add('Transfer start');
end;

procedure TFrmMain.VaYModem1TransferEnd(Sender: TObject;
  ExitCode: Integer);
begin
  Memo1.Lines.Add('Transfer finished ('+IntToStr(ExitCode)+')');
end;

procedure TFrmMain.VaYModem1PacketEvent(Sender: TObject; Packet,
  ByteCount: Integer);
begin
  Memo1.Lines.Add(Format('Packet %d, %d bytes', [Packet, ByteCount]));
end;

procedure TFrmMain.VaYModem1Error(Sender: TObject; ErrorCode,
  ErrorCount: Integer);
begin
  Memo1.Lines.Add(Format('Error %d, Total %d', [ErrorCode, ErrorCount]));
end;

procedure TFrmMain.Button1Click(Sender: TObject);
begin
  Application.Terminate;
end;


procedure TFrmMain.Button2Click(Sender: TObject);
begin
  VAconfigdialog1.Execute;
end;

end.
